﻿Imports System.IO
Public Class Film
    Private _Path As String
    Private _Name As String
    Private _Videos As List(Of Video)

    Sub New(Path As String)
        Me._Path = Path
        Me._Name = New DirectoryInfo(Path).Name
    End Sub

    Public ReadOnly Property Name As String
        Get
            Return _Name
        End Get
    End Property

    Public ReadOnly Property Path As String
        Get
            Return _Path
        End Get
    End Property

    Public ReadOnly Property NbFichierVideo As Integer
        Get
            If IsNothing(_Videos) Then Return 0 Else Return _Videos.Count
        End Get
    End Property

    Public ReadOnly Property Videos As List(Of Video)
        Get
            If IsNothing(_Videos) Then Return Nothing Else Return _Videos
        End Get
    End Property

    Sub AjouterVideo(video As Video)
        If IsNothing(Me._Videos) Then Me._Videos = New List(Of Video)
        Me._Videos.Add(video)
    End Sub



End Class

Public Class FilmCollection

    Private _Films As List(Of Film)
    Private _EmptyDirectory As List(Of String)

    Public ReadOnly Property Films As List(Of Film)
        Get
            Return Me._Films
        End Get
    End Property
    Public ReadOnly Property FilmsSansVideo As List(Of String)
        Get
            Return Me._EmptyDirectory
        End Get
    End Property


    Public ReadOnly Property NbFilms As Integer
        Get
            Return Me._Films.Count
        End Get
    End Property

    Public ReadOnly Property nbEmptyDirectory As Integer
        Get
            Return Me._EmptyDirectory.Count
        End Get
    End Property

    Public Sub New()
        Me._Films = New List(Of Film)
        Me._EmptyDirectory = New List(Of String)
    End Sub

    'Public Sub New(Directory As String)
    '    Me.New()

    'End Sub

    Public Sub ScanDirectory(Directory As String)

        Me._Films.Clear()
        Me._EmptyDirectory.Clear()
        Dim nbRepLimit As Integer = 50
        Dim nbRep As Integer = 0

        Dim query = From dir In My.Computer.FileSystem.GetDirectories(Directory, FileIO.SearchOption.SearchTopLevelOnly) Order By dir

        Dim film As Film
        Dim fichierVideoCol As System.Collections.ObjectModel.ReadOnlyCollection(Of String)
        Dim FichierVideo As Video

        For Each item In query
            fichierVideoCol = My.Computer.FileSystem.GetFiles(item, FileIO.SearchOption.SearchTopLevelOnly, {"*.avi", "*.mp4", "*.mkv"})

            If fichierVideoCol.Count > 0 Then
                film = New Film(item)

                For Each fichier As String In fichierVideoCol
                    FichierVideo = New Video(fichier)
                    film.AjouterVideo(FichierVideo)
                Next
                Me._Films.Add(film)
            Else
                Me._EmptyDirectory.Add(item)
            End If

            'Controle de dépassement du nb de films à scanner
            nbRep += 1
            If nbRep = nbRepLimit Then Exit For

        Next

    End Sub

    Public Sub Extraction()
        For Each film In Me._Films
            For Each video In film.Videos
                video.ExtractInfos()
            Next
        Next

    End Sub

End Class


