﻿Imports System.IO

Public Delegate Sub ExtractionGeneraleTermineEventHandler(ByVal sender As Object, ByVal e As ExtractionGeneraleTermineEventArgs)

Public Class ExtractionGeneraleTermineEventArgs
    Inherits System.EventArgs
End Class


Public Class Video

    Public Event ExtractionGeneraleTermine As ExtractionGeneraleTermineEventHandler

    Private _FullPath As String
    Private _Name As String
    Private _GeneralInfos As Dictionary(Of String, Object)


    Protected Friend ReadOnly Property FullPath As String
        Get
            Return _FullPath
        End Get
    End Property

    Public ReadOnly Property Name As String
        Get
            Return _Name
        End Get
    End Property

    Public ReadOnly Property GeneralInfos As Dictionary(Of String, Object)
        Get
            Return _GeneralInfos
        End Get
    End Property

    Public ReadOnly Property GeneralInfos(ByVal key As String) As Object
        Get
            If IsNothing(_GeneralInfos) OrElse Not _GeneralInfos.ContainsKey(key) Then Return Nothing
            Return _GeneralInfos(key)
        End Get
    End Property



    Sub New(FileName As String)
        Me._FullPath = FileName
        Me._Name = New FileInfo(FileName).Name
    End Sub

    Public Sub ExtractInfos()

        ExtractInfo_Generale()

    End Sub

    Public Sub ExtractInfo_Generale()

        If IsNothing(_GeneralInfos) Then _GeneralInfos = New Dictionary(Of String, Object)

        Dim MI As New MediaInfoLib.MediaInfo
        If MI.Open(_FullPath) = 1 Then
            With Me.GeneralInfos
                .Add("UniqueID", MI.Get(MediaInfoLib.StreamKind.General, 0, "UniqueID"))
                .Add("Duration/String3", MI.Get(MediaInfoLib.StreamKind.General, 0, "Duration/String3"))
                .Add("FileSize", MI.Get(MediaInfoLib.StreamKind.General, 0, "FileSize"))

            End With
            MI.Close()
        End If

        RaiseEvent ExtractionGeneraleTermine(Me, New ExtractionGeneraleTermineEventArgs())


    End Sub

    Public Sub ExtractInfo_Generale2()
        If IsNothing(_GeneralInfos) Then _GeneralInfos = New Dictionary(Of String, Object)

        Dim MI As New MediaInfoLib.MediaInfo
        If MI.Open(_FullPath) = 1 Then
            MI.Option("Complete")
            MI.Close()
        End If

    End Sub



End Class



